using System;
using System.ComponentModel;
using System.Globalization;
using System.Collections;
using System.Reflection;
using System.ComponentModel.Design.Serialization;
using Stimulsoft.Report.Components;

namespace CustomComponent
{
    public class StiCustomCodeExpressionConverter : TypeConverter
	{
		public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
		{
			if (sourceType == typeof(string))return true; 
			return base.CanConvertFrom(context, sourceType); 
		} 

		public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
		{
			if (destinationType == typeof(InstanceDescriptor))return true; 
			return base.CanConvertTo(context, destinationType); 
		} 

		public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
		{
			if (value is string)
			{
                return new StiCustomCodeExpression((string)value);
			}
			return base.ConvertFrom(context, culture, value); 
		}

		public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
		{
			if (destinationType == null)
				throw new ArgumentNullException("destinationType");
			
			if (destinationType == typeof(string))
			{
				if (value == null)return string.Empty;
				return ((StiExpression)value).Value;
			}

			return base.ConvertTo(context, culture, value, destinationType); 
		}
	}
}
